mbed TLS v2.16.0: camellia.h File Reference

mbed TLS v2.16.0

Data Structures | Macros | Typedefs | Functions
camellia.h File Reference

Camellia block cipher. More...

`#include "config.h"`
`#include <stddef.h>`
`#include <stdint.h>`
`#include "platform_util.h"`
Include dependency graph for camellia.h:

Go to the source code of this file.

## Data Structures
struct | mbedtls_camellia_context
| CAMELLIA context structure. More...

## Macros
#define | MBEDTLS_CAMELLIA_ENCRYPT 1
#define | MBEDTLS_CAMELLIA_DECRYPT 0
#define | MBEDTLS_ERR_CAMELLIA_INVALID_KEY_LENGTH MBEDTLS_DEPRECATED_NUMERIC_CONSTANT( -0x0024 )
#define | MBEDTLS_ERR_CAMELLIA_BAD_INPUT_DATA -0x0024
#define | MBEDTLS_ERR_CAMELLIA_INVALID_INPUT_LENGTH -0x0026
#define | MBEDTLS_ERR_CAMELLIA_HW_ACCEL_FAILED -0x0027

## Typedefs
typedef struct mbedtls_camellia_context | mbedtls_camellia_context
| CAMELLIA context structure. More...

## Functions
void | mbedtls_camellia_init (mbedtls_camellia_context *ctx)
| Initialize a CAMELLIA context. More...
void | mbedtls_camellia_free (mbedtls_camellia_context *ctx)
| Clear a CAMELLIA context. More...
int | mbedtls_camellia_setkey_enc (mbedtls_camellia_context *ctx, const unsigned char *key, unsigned int keybits)
| Perform a CAMELLIA key schedule operation for encryption. More...
int | mbedtls_camellia_setkey_dec (mbedtls_camellia_context *ctx, const unsigned char *key, unsigned int keybits)
| Perform a CAMELLIA key schedule operation for decryption. More...
int | mbedtls_camellia_crypt_ecb (mbedtls_camellia_context *ctx, int mode, const unsigned char input[16], unsigned char output[16])
| Perform a CAMELLIA-ECB block encryption/decryption operation. More...
int | mbedtls_camellia_crypt_cbc (mbedtls_camellia_context *ctx, int mode, size_t length, unsigned char iv[16], const unsigned char *input, unsigned char *output)
| Perform a CAMELLIA-CBC buffer encryption/decryption operation. More...
int | mbedtls_camellia_crypt_cfb128 (mbedtls_camellia_context *ctx, int mode, size_t length, size_t *iv_off, unsigned char iv[16], const unsigned char *input, unsigned char *output)
| Perform a CAMELLIA-CFB128 buffer encryption/decryption operation. More...
int | mbedtls_camellia_crypt_ctr (mbedtls_camellia_context *ctx, size_t length, size_t *nc_off, unsigned char nonce_counter[16], unsigned char stream_block[16], const unsigned char *input, unsigned char *output)
| Perform a CAMELLIA-CTR buffer encryption/decryption operation. More...
int | mbedtls_camellia_self_test (int verbose)
| Checkup routine. More...

## Detailed Description

Camellia block cipher.

Definition in file camellia.h.

## Macro Definition Documentation

## ◆ MBEDTLS_CAMELLIA_DECRYPT

#define MBEDTLS_CAMELLIA_DECRYPT 0

Definition at line 39 of file camellia.h.

## ◆ MBEDTLS_CAMELLIA_ENCRYPT

#define MBEDTLS_CAMELLIA_ENCRYPT 1

Definition at line 38 of file camellia.h.

## ◆ MBEDTLS_ERR_CAMELLIA_BAD_INPUT_DATA

#define MBEDTLS_ERR_CAMELLIA_BAD_INPUT_DATA -0x0024

Bad input data.

Definition at line 44 of file camellia.h.

## ◆ MBEDTLS_ERR_CAMELLIA_HW_ACCEL_FAILED

#define MBEDTLS_ERR_CAMELLIA_HW_ACCEL_FAILED -0x0027

Camellia hardware accelerator failed.

Definition at line 50 of file camellia.h.

## ◆ MBEDTLS_ERR_CAMELLIA_INVALID_INPUT_LENGTH

#define MBEDTLS_ERR_CAMELLIA_INVALID_INPUT_LENGTH -0x0026

Invalid data input length.

Definition at line 46 of file camellia.h.

## ◆ MBEDTLS_ERR_CAMELLIA_INVALID_KEY_LENGTH

#define MBEDTLS_ERR_CAMELLIA_INVALID_KEY_LENGTH MBEDTLS_DEPRECATED_NUMERIC_CONSTANT( -0x0024 )

Definition at line 42 of file camellia.h.

## Typedef Documentation

## ◆ mbedtls_camellia_context

typedef struct mbedtls_camellia_context mbedtls_camellia_context

CAMELLIA context structure.

## Function Documentation

## ◆ mbedtls_camellia_crypt_cbc()

int mbedtls_camellia_crypt_cbc | ( | mbedtls_camellia_context * | ctx,
|  | int | mode,
|  | size_t | length,
|  | unsigned char | iv[16],
|  | const unsigned char * | input,
|  | unsigned char * | output
| ) |  |

Perform a CAMELLIA-CBC buffer encryption/decryption operation.

Note
  Upon exit, the content of the IV is updated so that you can call the function same function again on the following block(s) of data and get the same result as if it was encrypted in one call. This allows a "streaming" usage. If on the other hand you need to retain the contents of the IV, you should either save it manually or use the cipher module instead.

Parameters

  ctx | The CAMELLIA context to use. This must be initialized and bound to a key.
  mode | The mode of operation. This must be either MBEDTLS_CAMELLIA_ENCRYPT or MBEDTLS_CAMELLIA_DECRYPT.
  length | The length in Bytes of the input data `input`. This must be a multiple of `16` Bytes.
  iv | The initialization vector. This must be a read/write buffer of length `16` Bytes. It is updated to allow streaming use as explained above.
  input | The buffer holding the input data. This must point to a readable buffer of length `length` Bytes.
  output | The buffer holding the output data. This must point to a writable buffer of length `length` Bytes.

Returns
  `0` if successful.
  A negative error code on failure.

## ◆ mbedtls_camellia_crypt_cfb128()

int mbedtls_camellia_crypt_cfb128 | ( | mbedtls_camellia_context * | ctx,
|  | int | mode,
|  | size_t | length,
|  | size_t * | iv_off,
|  | unsigned char | iv[16],
|  | const unsigned char * | input,
|  | unsigned char * | output
| ) |  |

Perform a CAMELLIA-CFB128 buffer encryption/decryption operation.

Note
  Due to the nature of CFB mode, you should use the same key for both encryption and decryption. In particular, calls to this function should be preceded by a key-schedule via mbedtls_camellia_setkey_enc() regardless of whether `mode` is MBEDTLS_CAMELLIA_ENCRYPT or MBEDTLS_CAMELLIA_DECRYPT.
  Upon exit, the content of the IV is updated so that you can call the function same function again on the following block(s) of data and get the same result as if it was encrypted in one call. This allows a "streaming" usage. If on the other hand you need to retain the contents of the IV, you should either save it manually or use the cipher module instead.

Parameters

  ctx | The CAMELLIA context to use. This must be initialized and bound to a key.
  mode | The mode of operation. This must be either MBEDTLS_CAMELLIA_ENCRYPT or MBEDTLS_CAMELLIA_DECRYPT.
  length | The length of the input data `input`. Any value is allowed.
  iv_off | The current offset in the IV. This must be smaller than `16` Bytes. It is updated after this call to allow the aforementioned streaming usage.
  iv | The initialization vector. This must be a read/write buffer of length `16` Bytes. It is updated after this call to allow the aforementioned streaming usage.
  input | The buffer holding the input data. This must be a readable buffer of size `length` Bytes.
  output | The buffer to hold the output data. This must be a writable buffer of length `length` Bytes.

Returns
  `0` if successful.
  A negative error code on failure.

## ◆ mbedtls_camellia_crypt_ctr()

int mbedtls_camellia_crypt_ctr | ( | mbedtls_camellia_context * | ctx,
|  | size_t | length,
|  | size_t * | nc_off,
|  | unsigned char | nonce_counter[16],
|  | unsigned char | stream_block[16],
|  | const unsigned char * | input,
|  | unsigned char * | output
| ) |  |

Perform a CAMELLIA-CTR buffer encryption/decryption operation.

*note Due to the nature of CTR mode, you should use the same key for both encryption and decryption. In particular, calls to this function should be preceded by a key-schedule via mbedtls_camellia_setkey_enc() regardless of whether `mode` is MBEDTLS_CAMELLIA_ENCRYPT or MBEDTLS_CAMELLIA_DECRYPT.

Warning
  You must never reuse a nonce value with the same key. Doing so would void the encryption for the two messages encrypted with the same nonce and key.

There are two common strategies for managing nonces with CTR:

1. You can handle everything as a single message processed over successive calls to this function. In that case, you want to set `nonce_counter` and `nc_off` to 0 for the first call, and then preserve the values of `nonce_counter`, `nc_off` and `stream_block` across calls to this function as they will be updated by this function.

With this strategy, you must not encrypt more than 2**128 blocks of data with the same key.

1. You can encrypt separate messages by dividing the `nonce_counter` buffer in two areas: the first one used for a per-message nonce, handled by yourself, and the second one updated by this function internally.

For example, you might reserve the first `12` Bytes for the per-message nonce, and the last `4` Bytes for internal use. In that case, before calling this function on a new message you need to set the first `12` Bytes of `nonce_counter` to your chosen nonce value, the last four to `0`, and `nc_off` to `0` (which will cause `stream_block` to be ignored). That way, you can encrypt at most `2**96` messages of up to `2**32` blocks each with the same key.

The per-message nonce (or information sufficient to reconstruct it) needs to be communicated with the ciphertext and must be unique. The recommended way to ensure uniqueness is to use a message counter. An alternative is to generate random nonces, but this limits the number of messages that can be securely encrypted: for example, with 96-bit random nonces, you should not encrypt more than 2**32 messages with the same key.

Note that for both stategies, sizes are measured in blocks and that a CAMELLIA block is `16` Bytes.

Warning
  Upon return, `stream_block` contains sensitive data. Its content must not be written to insecure storage and should be securely discarded as soon as it's no longer needed.

Parameters

  ctx | The CAMELLIA context to use. This must be initialized and bound to a key.
  length | The length of the input data `input` in Bytes. Any value is allowed.
  nc_off | The offset in the current `stream_block` (for resuming within current cipher stream). The offset pointer to should be `0` at the start of a stream. It is updated at the end of this call.
  nonce_counter | The 128-bit nonce and counter. This must be a read/write buffer of length `16` Bytes.
  stream_block | The saved stream-block for resuming. This must be a read/write buffer of length `16` Bytes.
  input | The input data stream. This must be a readable buffer of size `length` Bytes.
  output | The output data stream. This must be a writable buffer of size `length` Bytes.

Returns
  `0` if successful.
  A negative error code on failure.

## ◆ mbedtls_camellia_crypt_ecb()

int mbedtls_camellia_crypt_ecb | ( | mbedtls_camellia_context * | ctx,
|  | int | mode,
|  | const unsigned char | input[16],
|  | unsigned char | output[16]
| ) |  |

Perform a CAMELLIA-ECB block encryption/decryption operation.

Parameters

  ctx | The CAMELLIA context to use. This must be initialized and bound to a key.
  mode | The mode of operation. This must be either MBEDTLS_CAMELLIA_ENCRYPT or MBEDTLS_CAMELLIA_DECRYPT.
  input | The input block. This must be a readable buffer of size `16` Bytes.
  output | The output block. This must be a writable buffer of size `16` Bytes.

Returns
  `0` if successful.
  A negative error code on failure.

## ◆ mbedtls_camellia_free()

void mbedtls_camellia_free | ( | mbedtls_camellia_context * | ctx | ) |

Clear a CAMELLIA context.

Parameters

  ctx | The CAMELLIA context to be cleared. This may be `NULL`, in which case this function returns immediately. If it is not `NULL`, it must be initialized.

## ◆ mbedtls_camellia_init()

void mbedtls_camellia_init | ( | mbedtls_camellia_context * | ctx | ) |

Initialize a CAMELLIA context.

Parameters

  ctx | The CAMELLIA context to be initialized. This must not be `NULL`.

## ◆ mbedtls_camellia_self_test()

int mbedtls_camellia_self_test | ( | int | verbose | ) |

Checkup routine.

Returns
  0 if successful, or 1 if the test failed

## ◆ mbedtls_camellia_setkey_dec()

int mbedtls_camellia_setkey_dec | ( | mbedtls_camellia_context * | ctx,
|  | const unsigned char * | key,
|  | unsigned int | keybits
| ) |  |

Perform a CAMELLIA key schedule operation for decryption.

Parameters

  ctx | The CAMELLIA context to use. This must be initialized.
  key | The decryption key. This must be a readable buffer of size `keybits` Bits.
  keybits | The length of `key` in Bits. This must be either `128`, `192` or `256`.

Returns
  `0` if successful.
  A negative error code on failure.

## ◆ mbedtls_camellia_setkey_enc()

int mbedtls_camellia_setkey_enc | ( | mbedtls_camellia_context * | ctx,
|  | const unsigned char * | key,
|  | unsigned int | keybits
| ) |  |

Perform a CAMELLIA key schedule operation for encryption.

Parameters

  ctx | The CAMELLIA context to use. This must be initialized.
  key | The encryption key to use. This must be a readable buffer of size `keybits` Bits.
  keybits | The length of `key` in Bits. This must be either `128`, `192` or `256`.

Returns
  `0` if successful.
  A negative error code on failure.